import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AmplifyAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#access_token AmplifyApp#access_token}.
     *
     * @stability stable
     */
    readonly accessToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#auto_branch_creation_patterns AmplifyApp#auto_branch_creation_patterns}.
     *
     * @stability stable
     */
    readonly autoBranchCreationPatterns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
     *
     * @stability stable
     */
    readonly basicAuthCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#build_spec AmplifyApp#build_spec}.
     *
     * @stability stable
     */
    readonly buildSpec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#description AmplifyApp#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_auto_branch_creation AmplifyApp#enable_auto_branch_creation}.
     *
     * @stability stable
     */
    readonly enableAutoBranchCreation?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_basic_auth AmplifyApp#enable_basic_auth}.
     *
     * @stability stable
     */
    readonly enableBasicAuth?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_branch_auto_build AmplifyApp#enable_branch_auto_build}.
     *
     * @stability stable
     */
    readonly enableBranchAutoBuild?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_branch_auto_deletion AmplifyApp#enable_branch_auto_deletion}.
     *
     * @stability stable
     */
    readonly enableBranchAutoDeletion?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#environment_variables AmplifyApp#environment_variables}.
     *
     * @stability stable
     */
    readonly environmentVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#iam_service_role_arn AmplifyApp#iam_service_role_arn}.
     *
     * @stability stable
     */
    readonly iamServiceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#name AmplifyApp#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#oauth_token AmplifyApp#oauth_token}.
     *
     * @stability stable
     */
    readonly oauthToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#platform AmplifyApp#platform}.
     *
     * @stability stable
     */
    readonly platform?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#repository AmplifyApp#repository}.
     *
     * @stability stable
     */
    readonly repository?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#tags AmplifyApp#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#tags_all AmplifyApp#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * auto_branch_creation_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#auto_branch_creation_config AmplifyApp#auto_branch_creation_config}
     *
     * @stability stable
     */
    readonly autoBranchCreationConfig?: AmplifyAppAutoBranchCreationConfig[];
    /**
     * custom_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#custom_rule AmplifyApp#custom_rule}
     *
     * @stability stable
     */
    readonly customRule?: AmplifyAppCustomRule[];
}
/**
 * @stability stable
 */
export declare class AmplifyAppProductionBranch extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get branchName(): string;
    /**
     * @stability stable
     */
    get lastDeployTime(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get thumbnailUrl(): string;
}
/**
 * @stability stable
 */
export interface AmplifyAppAutoBranchCreationConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
     *
     * @stability stable
     */
    readonly basicAuthCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#build_spec AmplifyApp#build_spec}.
     *
     * @stability stable
     */
    readonly buildSpec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_auto_build AmplifyApp#enable_auto_build}.
     *
     * @stability stable
     */
    readonly enableAutoBuild?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_basic_auth AmplifyApp#enable_basic_auth}.
     *
     * @stability stable
     */
    readonly enableBasicAuth?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_performance_mode AmplifyApp#enable_performance_mode}.
     *
     * @stability stable
     */
    readonly enablePerformanceMode?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#enable_pull_request_preview AmplifyApp#enable_pull_request_preview}.
     *
     * @stability stable
     */
    readonly enablePullRequestPreview?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#environment_variables AmplifyApp#environment_variables}.
     *
     * @stability stable
     */
    readonly environmentVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#framework AmplifyApp#framework}.
     *
     * @stability stable
     */
    readonly framework?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#pull_request_environment_name AmplifyApp#pull_request_environment_name}.
     *
     * @stability stable
     */
    readonly pullRequestEnvironmentName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#stage AmplifyApp#stage}.
     *
     * @stability stable
     */
    readonly stage?: string;
}
/**
 * @stability stable
 */
export interface AmplifyAppCustomRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#condition AmplifyApp#condition}.
     *
     * @stability stable
     */
    readonly condition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#source AmplifyApp#source}.
     *
     * @stability stable
     */
    readonly source: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#status AmplifyApp#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html#target AmplifyApp#target}.
     *
     * @stability stable
     */
    readonly target: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html aws_amplify_app}.
 *
 * @stability stable
 */
export declare class AmplifyApp extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_app.html aws_amplify_app} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmplifyAppConfig);
    private _accessToken?;
    /**
     * @stability stable
     */
    get accessToken(): string;
    /**
     * @stability stable
     */
    set accessToken(value: string);
    /**
     * @stability stable
     */
    resetAccessToken(): void;
    /**
     * @stability stable
     */
    get accessTokenInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoBranchCreationPatterns?;
    /**
     * @stability stable
     */
    get autoBranchCreationPatterns(): string[];
    /**
     * @stability stable
     */
    set autoBranchCreationPatterns(value: string[]);
    /**
     * @stability stable
     */
    resetAutoBranchCreationPatterns(): void;
    /**
     * @stability stable
     */
    get autoBranchCreationPatternsInput(): string[] | undefined;
    private _basicAuthCredentials?;
    /**
     * @stability stable
     */
    get basicAuthCredentials(): string;
    /**
     * @stability stable
     */
    set basicAuthCredentials(value: string);
    /**
     * @stability stable
     */
    resetBasicAuthCredentials(): void;
    /**
     * @stability stable
     */
    get basicAuthCredentialsInput(): string | undefined;
    private _buildSpec?;
    /**
     * @stability stable
     */
    get buildSpec(): string;
    /**
     * @stability stable
     */
    set buildSpec(value: string);
    /**
     * @stability stable
     */
    resetBuildSpec(): void;
    /**
     * @stability stable
     */
    get buildSpecInput(): string | undefined;
    /**
     * @stability stable
     */
    get defaultDomain(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enableAutoBranchCreation?;
    /**
     * @stability stable
     */
    get enableAutoBranchCreation(): boolean;
    /**
     * @stability stable
     */
    set enableAutoBranchCreation(value: boolean);
    /**
     * @stability stable
     */
    resetEnableAutoBranchCreation(): void;
    /**
     * @stability stable
     */
    get enableAutoBranchCreationInput(): boolean | undefined;
    private _enableBasicAuth?;
    /**
     * @stability stable
     */
    get enableBasicAuth(): boolean;
    /**
     * @stability stable
     */
    set enableBasicAuth(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBasicAuth(): void;
    /**
     * @stability stable
     */
    get enableBasicAuthInput(): boolean | undefined;
    private _enableBranchAutoBuild?;
    /**
     * @stability stable
     */
    get enableBranchAutoBuild(): boolean;
    /**
     * @stability stable
     */
    set enableBranchAutoBuild(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBranchAutoBuild(): void;
    /**
     * @stability stable
     */
    get enableBranchAutoBuildInput(): boolean | undefined;
    private _enableBranchAutoDeletion?;
    /**
     * @stability stable
     */
    get enableBranchAutoDeletion(): boolean;
    /**
     * @stability stable
     */
    set enableBranchAutoDeletion(value: boolean);
    /**
     * @stability stable
     */
    resetEnableBranchAutoDeletion(): void;
    /**
     * @stability stable
     */
    get enableBranchAutoDeletionInput(): boolean | undefined;
    private _environmentVariables?;
    /**
     * @stability stable
     */
    get environmentVariables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set environmentVariables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetEnvironmentVariables(): void;
    /**
     * @stability stable
     */
    get environmentVariablesInput(): {
        [key: string]: string;
    } | undefined;
    private _iamServiceRoleArn?;
    /**
     * @stability stable
     */
    get iamServiceRoleArn(): string;
    /**
     * @stability stable
     */
    set iamServiceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get iamServiceRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _oauthToken?;
    /**
     * @stability stable
     */
    get oauthToken(): string;
    /**
     * @stability stable
     */
    set oauthToken(value: string);
    /**
     * @stability stable
     */
    resetOauthToken(): void;
    /**
     * @stability stable
     */
    get oauthTokenInput(): string | undefined;
    private _platform?;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    set platform(value: string);
    /**
     * @stability stable
     */
    resetPlatform(): void;
    /**
     * @stability stable
     */
    get platformInput(): string | undefined;
    /**
     * @stability stable
     */
    productionBranch(index: string): AmplifyAppProductionBranch;
    private _repository?;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    resetRepository(): void;
    /**
     * @stability stable
     */
    get repositoryInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _autoBranchCreationConfig?;
    /**
     * @stability stable
     */
    get autoBranchCreationConfig(): AmplifyAppAutoBranchCreationConfig[];
    /**
     * @stability stable
     */
    set autoBranchCreationConfig(value: AmplifyAppAutoBranchCreationConfig[]);
    /**
     * @stability stable
     */
    resetAutoBranchCreationConfig(): void;
    /**
     * @stability stable
     */
    get autoBranchCreationConfigInput(): AmplifyAppAutoBranchCreationConfig[] | undefined;
    private _customRule?;
    /**
     * @stability stable
     */
    get customRule(): AmplifyAppCustomRule[];
    /**
     * @stability stable
     */
    set customRule(value: AmplifyAppCustomRule[]);
    /**
     * @stability stable
     */
    resetCustomRule(): void;
    /**
     * @stability stable
     */
    get customRuleInput(): AmplifyAppCustomRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
