import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2ApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#api_key_selection_expression Apigatewayv2Api#api_key_selection_expression}.
     *
     * @stability stable
     */
    readonly apiKeySelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#body Apigatewayv2Api#body}.
     *
     * @stability stable
     */
    readonly body?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#credentials_arn Apigatewayv2Api#credentials_arn}.
     *
     * @stability stable
     */
    readonly credentialsArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#description Apigatewayv2Api#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#disable_execute_api_endpoint Apigatewayv2Api#disable_execute_api_endpoint}.
     *
     * @stability stable
     */
    readonly disableExecuteApiEndpoint?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#fail_on_warnings Apigatewayv2Api#fail_on_warnings}.
     *
     * @stability stable
     */
    readonly failOnWarnings?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#name Apigatewayv2Api#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#protocol_type Apigatewayv2Api#protocol_type}.
     *
     * @stability stable
     */
    readonly protocolType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#route_key Apigatewayv2Api#route_key}.
     *
     * @stability stable
     */
    readonly routeKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#route_selection_expression Apigatewayv2Api#route_selection_expression}.
     *
     * @stability stable
     */
    readonly routeSelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#tags Apigatewayv2Api#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#tags_all Apigatewayv2Api#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#target Apigatewayv2Api#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#version Apigatewayv2Api#version}.
     *
     * @stability stable
     */
    readonly version?: string;
    /**
     * cors_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#cors_configuration Apigatewayv2Api#cors_configuration}
     *
     * @stability stable
     */
    readonly corsConfiguration?: Apigatewayv2ApiCorsConfiguration[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2ApiCorsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_credentials Apigatewayv2Api#allow_credentials}.
     *
     * @stability stable
     */
    readonly allowCredentials?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_headers Apigatewayv2Api#allow_headers}.
     *
     * @stability stable
     */
    readonly allowHeaders?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_methods Apigatewayv2Api#allow_methods}.
     *
     * @stability stable
     */
    readonly allowMethods?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#allow_origins Apigatewayv2Api#allow_origins}.
     *
     * @stability stable
     */
    readonly allowOrigins?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#expose_headers Apigatewayv2Api#expose_headers}.
     *
     * @stability stable
     */
    readonly exposeHeaders?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html#max_age Apigatewayv2Api#max_age}.
     *
     * @stability stable
     */
    readonly maxAge?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html aws_apigatewayv2_api}.
 *
 * @stability stable
 */
export declare class Apigatewayv2Api extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_api.html aws_apigatewayv2_api} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2ApiConfig);
    /**
     * @stability stable
     */
    get apiEndpoint(): string;
    private _apiKeySelectionExpression?;
    /**
     * @stability stable
     */
    get apiKeySelectionExpression(): string;
    /**
     * @stability stable
     */
    set apiKeySelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetApiKeySelectionExpression(): void;
    /**
     * @stability stable
     */
    get apiKeySelectionExpressionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _body?;
    /**
     * @stability stable
     */
    get body(): string;
    /**
     * @stability stable
     */
    set body(value: string);
    /**
     * @stability stable
     */
    resetBody(): void;
    /**
     * @stability stable
     */
    get bodyInput(): string | undefined;
    private _credentialsArn?;
    /**
     * @stability stable
     */
    get credentialsArn(): string;
    /**
     * @stability stable
     */
    set credentialsArn(value: string);
    /**
     * @stability stable
     */
    resetCredentialsArn(): void;
    /**
     * @stability stable
     */
    get credentialsArnInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableExecuteApiEndpoint?;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpoint(): boolean;
    /**
     * @stability stable
     */
    set disableExecuteApiEndpoint(value: boolean);
    /**
     * @stability stable
     */
    resetDisableExecuteApiEndpoint(): void;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpointInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    private _failOnWarnings?;
    /**
     * @stability stable
     */
    get failOnWarnings(): boolean;
    /**
     * @stability stable
     */
    set failOnWarnings(value: boolean);
    /**
     * @stability stable
     */
    resetFailOnWarnings(): void;
    /**
     * @stability stable
     */
    get failOnWarningsInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _protocolType;
    /**
     * @stability stable
     */
    get protocolType(): string;
    /**
     * @stability stable
     */
    set protocolType(value: string);
    /**
     * @stability stable
     */
    get protocolTypeInput(): string;
    private _routeKey?;
    /**
     * @stability stable
     */
    get routeKey(): string;
    /**
     * @stability stable
     */
    set routeKey(value: string);
    /**
     * @stability stable
     */
    resetRouteKey(): void;
    /**
     * @stability stable
     */
    get routeKeyInput(): string | undefined;
    private _routeSelectionExpression?;
    /**
     * @stability stable
     */
    get routeSelectionExpression(): string;
    /**
     * @stability stable
     */
    set routeSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetRouteSelectionExpression(): void;
    /**
     * @stability stable
     */
    get routeSelectionExpressionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _corsConfiguration?;
    /**
     * @stability stable
     */
    get corsConfiguration(): Apigatewayv2ApiCorsConfiguration[];
    /**
     * @stability stable
     */
    set corsConfiguration(value: Apigatewayv2ApiCorsConfiguration[]);
    /**
     * @stability stable
     */
    resetCorsConfiguration(): void;
    /**
     * @stability stable
     */
    get corsConfigurationInput(): Apigatewayv2ApiCorsConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
