import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApprunnerServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#auto_scaling_configuration_arn ApprunnerService#auto_scaling_configuration_arn}.
     *
     * @stability stable
     */
    readonly autoScalingConfigurationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#service_name ApprunnerService#service_name}.
     *
     * @stability stable
     */
    readonly serviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#tags ApprunnerService#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#tags_all ApprunnerService#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * encryption_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#encryption_configuration ApprunnerService#encryption_configuration}
     *
     * @stability stable
     */
    readonly encryptionConfiguration?: ApprunnerServiceEncryptionConfiguration[];
    /**
     * health_check_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#health_check_configuration ApprunnerService#health_check_configuration}
     *
     * @stability stable
     */
    readonly healthCheckConfiguration?: ApprunnerServiceHealthCheckConfiguration[];
    /**
     * instance_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#instance_configuration ApprunnerService#instance_configuration}
     *
     * @stability stable
     */
    readonly instanceConfiguration?: ApprunnerServiceInstanceConfiguration[];
    /**
     * source_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#source_configuration ApprunnerService#source_configuration}
     *
     * @stability stable
     */
    readonly sourceConfiguration: ApprunnerServiceSourceConfiguration[];
}
/**
 * @stability stable
 */
export interface ApprunnerServiceEncryptionConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#kms_key ApprunnerService#kms_key}.
     *
     * @stability stable
     */
    readonly kmsKey: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceHealthCheckConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#healthy_threshold ApprunnerService#healthy_threshold}.
     *
     * @stability stable
     */
    readonly healthyThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#interval ApprunnerService#interval}.
     *
     * @stability stable
     */
    readonly interval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#path ApprunnerService#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#protocol ApprunnerService#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#timeout ApprunnerService#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#unhealthy_threshold ApprunnerService#unhealthy_threshold}.
     *
     * @stability stable
     */
    readonly unhealthyThreshold?: number;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceInstanceConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#cpu ApprunnerService#cpu}.
     *
     * @stability stable
     */
    readonly cpu?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#instance_role_arn ApprunnerService#instance_role_arn}.
     *
     * @stability stable
     */
    readonly instanceRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#memory ApprunnerService#memory}.
     *
     * @stability stable
     */
    readonly memory?: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationAuthenticationConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#access_role_arn ApprunnerService#access_role_arn}.
     *
     * @stability stable
     */
    readonly accessRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#connection_arn ApprunnerService#connection_arn}.
     *
     * @stability stable
     */
    readonly connectionArn?: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#build_command ApprunnerService#build_command}.
     *
     * @stability stable
     */
    readonly buildCommand?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#port ApprunnerService#port}.
     *
     * @stability stable
     */
    readonly port?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime ApprunnerService#runtime}.
     *
     * @stability stable
     */
    readonly runtime: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime_environment_variables ApprunnerService#runtime_environment_variables}.
     *
     * @stability stable
     */
    readonly runtimeEnvironmentVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#start_command ApprunnerService#start_command}.
     *
     * @stability stable
     */
    readonly startCommand?: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#configuration_source ApprunnerService#configuration_source}.
     *
     * @stability stable
     */
    readonly configurationSource: string;
    /**
     * code_configuration_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_configuration_values ApprunnerService#code_configuration_values}
     *
     * @stability stable
     */
    readonly codeConfigurationValues?: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfigurationCodeConfigurationValues[];
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#type ApprunnerService#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#value ApprunnerService#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationCodeRepository {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#repository_url ApprunnerService#repository_url}.
     *
     * @stability stable
     */
    readonly repositoryUrl: string;
    /**
     * code_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_configuration ApprunnerService#code_configuration}
     *
     * @stability stable
     */
    readonly codeConfiguration?: ApprunnerServiceSourceConfigurationCodeRepositoryCodeConfiguration[];
    /**
     * source_code_version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#source_code_version ApprunnerService#source_code_version}
     *
     * @stability stable
     */
    readonly sourceCodeVersion: ApprunnerServiceSourceConfigurationCodeRepositorySourceCodeVersion[];
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#port ApprunnerService#port}.
     *
     * @stability stable
     */
    readonly port?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#runtime_environment_variables ApprunnerService#runtime_environment_variables}.
     *
     * @stability stable
     */
    readonly runtimeEnvironmentVariables?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#start_command ApprunnerService#start_command}.
     *
     * @stability stable
     */
    readonly startCommand?: string;
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfigurationImageRepository {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_identifier ApprunnerService#image_identifier}.
     *
     * @stability stable
     */
    readonly imageIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_repository_type ApprunnerService#image_repository_type}.
     *
     * @stability stable
     */
    readonly imageRepositoryType: string;
    /**
     * image_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_configuration ApprunnerService#image_configuration}
     *
     * @stability stable
     */
    readonly imageConfiguration?: ApprunnerServiceSourceConfigurationImageRepositoryImageConfiguration[];
}
/**
 * @stability stable
 */
export interface ApprunnerServiceSourceConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#auto_deployments_enabled ApprunnerService#auto_deployments_enabled}.
     *
     * @stability stable
     */
    readonly autoDeploymentsEnabled?: boolean;
    /**
     * authentication_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#authentication_configuration ApprunnerService#authentication_configuration}
     *
     * @stability stable
     */
    readonly authenticationConfiguration?: ApprunnerServiceSourceConfigurationAuthenticationConfiguration[];
    /**
     * code_repository block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#code_repository ApprunnerService#code_repository}
     *
     * @stability stable
     */
    readonly codeRepository?: ApprunnerServiceSourceConfigurationCodeRepository[];
    /**
     * image_repository block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html#image_repository ApprunnerService#image_repository}
     *
     * @stability stable
     */
    readonly imageRepository?: ApprunnerServiceSourceConfigurationImageRepository[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html aws_apprunner_service}.
 *
 * @stability stable
 */
export declare class ApprunnerService extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apprunner_service.html aws_apprunner_service} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApprunnerServiceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoScalingConfigurationArn?;
    /**
     * @stability stable
     */
    get autoScalingConfigurationArn(): string;
    /**
     * @stability stable
     */
    set autoScalingConfigurationArn(value: string);
    /**
     * @stability stable
     */
    resetAutoScalingConfigurationArn(): void;
    /**
     * @stability stable
     */
    get autoScalingConfigurationArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get serviceId(): string;
    private _serviceName;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    get serviceNameInput(): string;
    /**
     * @stability stable
     */
    get serviceUrl(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _encryptionConfiguration?;
    /**
     * @stability stable
     */
    get encryptionConfiguration(): ApprunnerServiceEncryptionConfiguration[];
    /**
     * @stability stable
     */
    set encryptionConfiguration(value: ApprunnerServiceEncryptionConfiguration[]);
    /**
     * @stability stable
     */
    resetEncryptionConfiguration(): void;
    /**
     * @stability stable
     */
    get encryptionConfigurationInput(): ApprunnerServiceEncryptionConfiguration[] | undefined;
    private _healthCheckConfiguration?;
    /**
     * @stability stable
     */
    get healthCheckConfiguration(): ApprunnerServiceHealthCheckConfiguration[];
    /**
     * @stability stable
     */
    set healthCheckConfiguration(value: ApprunnerServiceHealthCheckConfiguration[]);
    /**
     * @stability stable
     */
    resetHealthCheckConfiguration(): void;
    /**
     * @stability stable
     */
    get healthCheckConfigurationInput(): ApprunnerServiceHealthCheckConfiguration[] | undefined;
    private _instanceConfiguration?;
    /**
     * @stability stable
     */
    get instanceConfiguration(): ApprunnerServiceInstanceConfiguration[];
    /**
     * @stability stable
     */
    set instanceConfiguration(value: ApprunnerServiceInstanceConfiguration[]);
    /**
     * @stability stable
     */
    resetInstanceConfiguration(): void;
    /**
     * @stability stable
     */
    get instanceConfigurationInput(): ApprunnerServiceInstanceConfiguration[] | undefined;
    private _sourceConfiguration;
    /**
     * @stability stable
     */
    get sourceConfiguration(): ApprunnerServiceSourceConfiguration[];
    /**
     * @stability stable
     */
    set sourceConfiguration(value: ApprunnerServiceSourceConfiguration[]);
    /**
     * @stability stable
     */
    get sourceConfigurationInput(): ApprunnerServiceSourceConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
