import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchEventTargetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#arn CloudwatchEventTarget#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#event_bus_name CloudwatchEventTarget#event_bus_name}.
     *
     * @stability stable
     */
    readonly eventBusName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input CloudwatchEventTarget#input}.
     *
     * @stability stable
     */
    readonly input?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_path CloudwatchEventTarget#input_path}.
     *
     * @stability stable
     */
    readonly inputPath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#role_arn CloudwatchEventTarget#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#rule CloudwatchEventTarget#rule}.
     *
     * @stability stable
     */
    readonly rule: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#target_id CloudwatchEventTarget#target_id}.
     *
     * @stability stable
     */
    readonly targetId?: string;
    /**
     * batch_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#batch_target CloudwatchEventTarget#batch_target}
     *
     * @stability stable
     */
    readonly batchTarget?: CloudwatchEventTargetBatchTarget[];
    /**
     * dead_letter_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#dead_letter_config CloudwatchEventTarget#dead_letter_config}
     *
     * @stability stable
     */
    readonly deadLetterConfig?: CloudwatchEventTargetDeadLetterConfig[];
    /**
     * ecs_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#ecs_target CloudwatchEventTarget#ecs_target}
     *
     * @stability stable
     */
    readonly ecsTarget?: CloudwatchEventTargetEcsTarget[];
    /**
     * http_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#http_target CloudwatchEventTarget#http_target}
     *
     * @stability stable
     */
    readonly httpTarget?: CloudwatchEventTargetHttpTarget[];
    /**
     * input_transformer block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_transformer CloudwatchEventTarget#input_transformer}
     *
     * @stability stable
     */
    readonly inputTransformer?: CloudwatchEventTargetInputTransformer[];
    /**
     * kinesis_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#kinesis_target CloudwatchEventTarget#kinesis_target}
     *
     * @stability stable
     */
    readonly kinesisTarget?: CloudwatchEventTargetKinesisTarget[];
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#retry_policy CloudwatchEventTarget#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: CloudwatchEventTargetRetryPolicy[];
    /**
     * run_command_targets block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#run_command_targets CloudwatchEventTarget#run_command_targets}
     *
     * @stability stable
     */
    readonly runCommandTargets?: CloudwatchEventTargetRunCommandTargets[];
    /**
     * sqs_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#sqs_target CloudwatchEventTarget#sqs_target}
     *
     * @stability stable
     */
    readonly sqsTarget?: CloudwatchEventTargetSqsTarget[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetBatchTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#array_size CloudwatchEventTarget#array_size}.
     *
     * @stability stable
     */
    readonly arraySize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_attempts CloudwatchEventTarget#job_attempts}.
     *
     * @stability stable
     */
    readonly jobAttempts?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_definition CloudwatchEventTarget#job_definition}.
     *
     * @stability stable
     */
    readonly jobDefinition: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#job_name CloudwatchEventTarget#job_name}.
     *
     * @stability stable
     */
    readonly jobName: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetDeadLetterConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#arn CloudwatchEventTarget#arn}.
     *
     * @stability stable
     */
    readonly arn?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetEcsTargetNetworkConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#assign_public_ip CloudwatchEventTarget#assign_public_ip}.
     *
     * @stability stable
     */
    readonly assignPublicIp?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#security_groups CloudwatchEventTarget#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#subnets CloudwatchEventTarget#subnets}.
     *
     * @stability stable
     */
    readonly subnets: string[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetEcsTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#group CloudwatchEventTarget#group}.
     *
     * @stability stable
     */
    readonly group?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#launch_type CloudwatchEventTarget#launch_type}.
     *
     * @stability stable
     */
    readonly launchType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#platform_version CloudwatchEventTarget#platform_version}.
     *
     * @stability stable
     */
    readonly platformVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#task_count CloudwatchEventTarget#task_count}.
     *
     * @stability stable
     */
    readonly taskCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#task_definition_arn CloudwatchEventTarget#task_definition_arn}.
     *
     * @stability stable
     */
    readonly taskDefinitionArn: string;
    /**
     * network_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#network_configuration CloudwatchEventTarget#network_configuration}
     *
     * @stability stable
     */
    readonly networkConfiguration?: CloudwatchEventTargetEcsTargetNetworkConfiguration[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetHttpTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#header_parameters CloudwatchEventTarget#header_parameters}.
     *
     * @stability stable
     */
    readonly headerParameters?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#path_parameter_values CloudwatchEventTarget#path_parameter_values}.
     *
     * @stability stable
     */
    readonly pathParameterValues?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#query_string_parameters CloudwatchEventTarget#query_string_parameters}.
     *
     * @stability stable
     */
    readonly queryStringParameters?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetInputTransformer {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_paths CloudwatchEventTarget#input_paths}.
     *
     * @stability stable
     */
    readonly inputPaths?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#input_template CloudwatchEventTarget#input_template}.
     *
     * @stability stable
     */
    readonly inputTemplate: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetKinesisTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#partition_key_path CloudwatchEventTarget#partition_key_path}.
     *
     * @stability stable
     */
    readonly partitionKeyPath?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#maximum_event_age_in_seconds CloudwatchEventTarget#maximum_event_age_in_seconds}.
     *
     * @stability stable
     */
    readonly maximumEventAgeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#maximum_retry_attempts CloudwatchEventTarget#maximum_retry_attempts}.
     *
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetRunCommandTargets {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#key CloudwatchEventTarget#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#values CloudwatchEventTarget#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetSqsTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html#message_group_id CloudwatchEventTarget#message_group_id}.
     *
     * @stability stable
     */
    readonly messageGroupId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html aws_cloudwatch_event_target}.
 *
 * @stability stable
 */
export declare class CloudwatchEventTarget extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_event_target.html aws_cloudwatch_event_target} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchEventTargetConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    private _eventBusName?;
    /**
     * @stability stable
     */
    get eventBusName(): string;
    /**
     * @stability stable
     */
    set eventBusName(value: string);
    /**
     * @stability stable
     */
    resetEventBusName(): void;
    /**
     * @stability stable
     */
    get eventBusNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _input?;
    /**
     * @stability stable
     */
    get input(): string;
    /**
     * @stability stable
     */
    set input(value: string);
    /**
     * @stability stable
     */
    resetInput(): void;
    /**
     * @stability stable
     */
    get inputInput(): string | undefined;
    private _inputPath?;
    /**
     * @stability stable
     */
    get inputPath(): string;
    /**
     * @stability stable
     */
    set inputPath(value: string);
    /**
     * @stability stable
     */
    resetInputPath(): void;
    /**
     * @stability stable
     */
    get inputPathInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _rule;
    /**
     * @stability stable
     */
    get rule(): string;
    /**
     * @stability stable
     */
    set rule(value: string);
    /**
     * @stability stable
     */
    get ruleInput(): string;
    private _targetId?;
    /**
     * @stability stable
     */
    get targetId(): string;
    /**
     * @stability stable
     */
    set targetId(value: string);
    /**
     * @stability stable
     */
    resetTargetId(): void;
    /**
     * @stability stable
     */
    get targetIdInput(): string | undefined;
    private _batchTarget?;
    /**
     * @stability stable
     */
    get batchTarget(): CloudwatchEventTargetBatchTarget[];
    /**
     * @stability stable
     */
    set batchTarget(value: CloudwatchEventTargetBatchTarget[]);
    /**
     * @stability stable
     */
    resetBatchTarget(): void;
    /**
     * @stability stable
     */
    get batchTargetInput(): CloudwatchEventTargetBatchTarget[] | undefined;
    private _deadLetterConfig?;
    /**
     * @stability stable
     */
    get deadLetterConfig(): CloudwatchEventTargetDeadLetterConfig[];
    /**
     * @stability stable
     */
    set deadLetterConfig(value: CloudwatchEventTargetDeadLetterConfig[]);
    /**
     * @stability stable
     */
    resetDeadLetterConfig(): void;
    /**
     * @stability stable
     */
    get deadLetterConfigInput(): CloudwatchEventTargetDeadLetterConfig[] | undefined;
    private _ecsTarget?;
    /**
     * @stability stable
     */
    get ecsTarget(): CloudwatchEventTargetEcsTarget[];
    /**
     * @stability stable
     */
    set ecsTarget(value: CloudwatchEventTargetEcsTarget[]);
    /**
     * @stability stable
     */
    resetEcsTarget(): void;
    /**
     * @stability stable
     */
    get ecsTargetInput(): CloudwatchEventTargetEcsTarget[] | undefined;
    private _httpTarget?;
    /**
     * @stability stable
     */
    get httpTarget(): CloudwatchEventTargetHttpTarget[];
    /**
     * @stability stable
     */
    set httpTarget(value: CloudwatchEventTargetHttpTarget[]);
    /**
     * @stability stable
     */
    resetHttpTarget(): void;
    /**
     * @stability stable
     */
    get httpTargetInput(): CloudwatchEventTargetHttpTarget[] | undefined;
    private _inputTransformer?;
    /**
     * @stability stable
     */
    get inputTransformer(): CloudwatchEventTargetInputTransformer[];
    /**
     * @stability stable
     */
    set inputTransformer(value: CloudwatchEventTargetInputTransformer[]);
    /**
     * @stability stable
     */
    resetInputTransformer(): void;
    /**
     * @stability stable
     */
    get inputTransformerInput(): CloudwatchEventTargetInputTransformer[] | undefined;
    private _kinesisTarget?;
    /**
     * @stability stable
     */
    get kinesisTarget(): CloudwatchEventTargetKinesisTarget[];
    /**
     * @stability stable
     */
    set kinesisTarget(value: CloudwatchEventTargetKinesisTarget[]);
    /**
     * @stability stable
     */
    resetKinesisTarget(): void;
    /**
     * @stability stable
     */
    get kinesisTargetInput(): CloudwatchEventTargetKinesisTarget[] | undefined;
    private _retryPolicy?;
    /**
     * @stability stable
     */
    get retryPolicy(): CloudwatchEventTargetRetryPolicy[];
    /**
     * @stability stable
     */
    set retryPolicy(value: CloudwatchEventTargetRetryPolicy[]);
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): CloudwatchEventTargetRetryPolicy[] | undefined;
    private _runCommandTargets?;
    /**
     * @stability stable
     */
    get runCommandTargets(): CloudwatchEventTargetRunCommandTargets[];
    /**
     * @stability stable
     */
    set runCommandTargets(value: CloudwatchEventTargetRunCommandTargets[]);
    /**
     * @stability stable
     */
    resetRunCommandTargets(): void;
    /**
     * @stability stable
     */
    get runCommandTargetsInput(): CloudwatchEventTargetRunCommandTargets[] | undefined;
    private _sqsTarget?;
    /**
     * @stability stable
     */
    get sqsTarget(): CloudwatchEventTargetSqsTarget[];
    /**
     * @stability stable
     */
    set sqsTarget(value: CloudwatchEventTargetSqsTarget[]);
    /**
     * @stability stable
     */
    resetSqsTarget(): void;
    /**
     * @stability stable
     */
    get sqsTargetInput(): CloudwatchEventTargetSqsTarget[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
