import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#identity_pool_id CognitoIdentityPoolRolesAttachment#identity_pool_id}.
     *
     * @stability stable
     */
    readonly identityPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#roles CognitoIdentityPoolRolesAttachment#roles}.
     *
     * @stability stable
     */
    readonly roles: {
        [key: string]: string;
    };
    /**
     * role_mapping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#role_mapping CognitoIdentityPoolRolesAttachment#role_mapping}
     *
     * @stability stable
     */
    readonly roleMapping?: CognitoIdentityPoolRolesAttachmentRoleMapping[];
}
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentRoleMappingMappingRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#claim CognitoIdentityPoolRolesAttachment#claim}.
     *
     * @stability stable
     */
    readonly claim: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#match_type CognitoIdentityPoolRolesAttachment#match_type}.
     *
     * @stability stable
     */
    readonly matchType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#role_arn CognitoIdentityPoolRolesAttachment#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#value CognitoIdentityPoolRolesAttachment#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentRoleMapping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#ambiguous_role_resolution CognitoIdentityPoolRolesAttachment#ambiguous_role_resolution}.
     *
     * @stability stable
     */
    readonly ambiguousRoleResolution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#identity_provider CognitoIdentityPoolRolesAttachment#identity_provider}.
     *
     * @stability stable
     */
    readonly identityProvider: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#type CognitoIdentityPoolRolesAttachment#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * mapping_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html#mapping_rule CognitoIdentityPoolRolesAttachment#mapping_rule}
     *
     * @stability stable
     */
    readonly mappingRule?: CognitoIdentityPoolRolesAttachmentRoleMappingMappingRule[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html aws_cognito_identity_pool_roles_attachment}.
 *
 * @stability stable
 */
export declare class CognitoIdentityPoolRolesAttachment extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_identity_pool_roles_attachment.html aws_cognito_identity_pool_roles_attachment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoIdentityPoolRolesAttachmentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityPoolId;
    /**
     * @stability stable
     */
    get identityPoolId(): string;
    /**
     * @stability stable
     */
    set identityPoolId(value: string);
    /**
     * @stability stable
     */
    get identityPoolIdInput(): string;
    private _roles;
    /**
     * @stability stable
     */
    get roles(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set roles(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    get rolesInput(): {
        [key: string]: string;
    };
    private _roleMapping?;
    /**
     * @stability stable
     */
    get roleMapping(): CognitoIdentityPoolRolesAttachmentRoleMapping[];
    /**
     * @stability stable
     */
    set roleMapping(value: CognitoIdentityPoolRolesAttachmentRoleMapping[]);
    /**
     * @stability stable
     */
    resetRoleMapping(): void;
    /**
     * @stability stable
     */
    get roleMappingInput(): CognitoIdentityPoolRolesAttachmentRoleMapping[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
