import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZonesConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#all_availability_zones DataAwsAvailabilityZones#all_availability_zones}.
     *
     * @stability stable
     */
    readonly allAvailabilityZones?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#exclude_names DataAwsAvailabilityZones#exclude_names}.
     *
     * @stability stable
     */
    readonly excludeNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#exclude_zone_ids DataAwsAvailabilityZones#exclude_zone_ids}.
     *
     * @stability stable
     */
    readonly excludeZoneIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#state DataAwsAvailabilityZones#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#filter DataAwsAvailabilityZones#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsAvailabilityZonesFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZonesFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#name DataAwsAvailabilityZones#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html#values DataAwsAvailabilityZones#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html aws_availability_zones}.
 *
 * @stability stable
 */
export declare class DataAwsAvailabilityZones extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/availability_zones.html aws_availability_zones} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAvailabilityZonesConfig);
    private _allAvailabilityZones?;
    /**
     * @stability stable
     */
    get allAvailabilityZones(): boolean;
    /**
     * @stability stable
     */
    set allAvailabilityZones(value: boolean);
    /**
     * @stability stable
     */
    resetAllAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get allAvailabilityZonesInput(): boolean | undefined;
    private _excludeNames?;
    /**
     * @stability stable
     */
    get excludeNames(): string[];
    /**
     * @stability stable
     */
    set excludeNames(value: string[]);
    /**
     * @stability stable
     */
    resetExcludeNames(): void;
    /**
     * @stability stable
     */
    get excludeNamesInput(): string[] | undefined;
    private _excludeZoneIds?;
    /**
     * @stability stable
     */
    get excludeZoneIds(): string[];
    /**
     * @stability stable
     */
    set excludeZoneIds(value: string[]);
    /**
     * @stability stable
     */
    resetExcludeZoneIds(): void;
    /**
     * @stability stable
     */
    get excludeZoneIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get groupNames(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get names(): string[];
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    /**
     * @stability stable
     */
    get zoneIds(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAvailabilityZonesFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAvailabilityZonesFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAvailabilityZonesFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
