import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLbListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lb_listener.html#load_balancer_arn DataAwsLbListener#load_balancer_arn}.
     *
     * @stability stable
     */
    readonly loadBalancerArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lb_listener.html#port DataAwsLbListener#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lb_listener.html#tags DataAwsLbListener#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionAuthenticateCognito extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): any;
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get userPoolArn(): string;
    /**
     * @stability stable
     */
    get userPoolClientId(): string;
    /**
     * @stability stable
     */
    get userPoolDomain(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionAuthenticateOidc extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): any;
    /**
     * @stability stable
     */
    get authorizationEndpoint(): string;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    get clientSecret(): string;
    /**
     * @stability stable
     */
    get issuer(): string;
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get tokenEndpoint(): string;
    /**
     * @stability stable
     */
    get userInfoEndpoint(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionFixedResponse extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    get messageBody(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionForwardStickiness extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get duration(): number;
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionForwardTargetGroup extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get weight(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionForward extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get stickiness(): any;
    /**
     * @stability stable
     */
    get targetGroup(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultActionRedirect extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get port(): string;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLbListenerDefaultAction extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticateCognito(): any;
    /**
     * @stability stable
     */
    get authenticateOidc(): any;
    /**
     * @stability stable
     */
    get fixedResponse(): any;
    /**
     * @stability stable
     */
    get forward(): any;
    /**
     * @stability stable
     */
    get order(): number;
    /**
     * @stability stable
     */
    get redirect(): any;
    /**
     * @stability stable
     */
    get targetGroupArn(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lb_listener.html aws_lb_listener}.
 *
 * @stability stable
 */
export declare class DataAwsLbListener extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lb_listener.html aws_lb_listener} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsLbListenerConfig);
    /**
     * @stability stable
     */
    get alpnPolicy(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    defaultAction(index: string): DataAwsLbListenerDefaultAction;
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerArn?;
    /**
     * @stability stable
     */
    get loadBalancerArn(): string;
    /**
     * @stability stable
     */
    set loadBalancerArn(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancerArn(): void;
    /**
     * @stability stable
     */
    get loadBalancerArnInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get sslPolicy(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
