import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#db_proxy_name DbProxyDefaultTargetGroup#db_proxy_name}.
     *
     * @stability stable
     */
    readonly dbProxyName: string;
    /**
     * connection_pool_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#connection_pool_config DbProxyDefaultTargetGroup#connection_pool_config}
     *
     * @stability stable
     */
    readonly connectionPoolConfig?: DbProxyDefaultTargetGroupConnectionPoolConfig[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#timeouts DbProxyDefaultTargetGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DbProxyDefaultTargetGroupTimeouts;
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConnectionPoolConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#connection_borrow_timeout DbProxyDefaultTargetGroup#connection_borrow_timeout}.
     *
     * @stability stable
     */
    readonly connectionBorrowTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#init_query DbProxyDefaultTargetGroup#init_query}.
     *
     * @stability stable
     */
    readonly initQuery?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#max_connections_percent DbProxyDefaultTargetGroup#max_connections_percent}.
     *
     * @stability stable
     */
    readonly maxConnectionsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#max_idle_connections_percent DbProxyDefaultTargetGroup#max_idle_connections_percent}.
     *
     * @stability stable
     */
    readonly maxIdleConnectionsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#session_pinning_filters DbProxyDefaultTargetGroup#session_pinning_filters}.
     *
     * @stability stable
     */
    readonly sessionPinningFilters?: string[];
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#create DbProxyDefaultTargetGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html#update DbProxyDefaultTargetGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html aws_db_proxy_default_target_group}.
 *
 * @stability stable
 */
export declare class DbProxyDefaultTargetGroup extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group.html aws_db_proxy_default_target_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbProxyDefaultTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _dbProxyName;
    /**
     * @stability stable
     */
    get dbProxyName(): string;
    /**
     * @stability stable
     */
    set dbProxyName(value: string);
    /**
     * @stability stable
     */
    get dbProxyNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _connectionPoolConfig?;
    /**
     * @stability stable
     */
    get connectionPoolConfig(): DbProxyDefaultTargetGroupConnectionPoolConfig[];
    /**
     * @stability stable
     */
    set connectionPoolConfig(value: DbProxyDefaultTargetGroupConnectionPoolConfig[]);
    /**
     * @stability stable
     */
    resetConnectionPoolConfig(): void;
    /**
     * @stability stable
     */
    get connectionPoolConfigInput(): DbProxyDefaultTargetGroupConnectionPoolConfig[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbProxyDefaultTargetGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbProxyDefaultTargetGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbProxyDefaultTargetGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
