import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DynamodbTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#billing_mode DynamodbTable#billing_mode}.
     *
     * @stability stable
     */
    readonly billingMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#hash_key DynamodbTable#hash_key}.
     *
     * @stability stable
     */
    readonly hashKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#name DynamodbTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#range_key DynamodbTable#range_key}.
     *
     * @stability stable
     */
    readonly rangeKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#read_capacity DynamodbTable#read_capacity}.
     *
     * @stability stable
     */
    readonly readCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#stream_enabled DynamodbTable#stream_enabled}.
     *
     * @stability stable
     */
    readonly streamEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#stream_view_type DynamodbTable#stream_view_type}.
     *
     * @stability stable
     */
    readonly streamViewType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#tags DynamodbTable#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#tags_all DynamodbTable#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#write_capacity DynamodbTable#write_capacity}.
     *
     * @stability stable
     */
    readonly writeCapacity?: number;
    /**
     * attribute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#attribute DynamodbTable#attribute}
     *
     * @stability stable
     */
    readonly attribute: DynamodbTableAttribute[];
    /**
     * global_secondary_index block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#global_secondary_index DynamodbTable#global_secondary_index}
     *
     * @stability stable
     */
    readonly globalSecondaryIndex?: DynamodbTableGlobalSecondaryIndex[];
    /**
     * local_secondary_index block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#local_secondary_index DynamodbTable#local_secondary_index}
     *
     * @stability stable
     */
    readonly localSecondaryIndex?: DynamodbTableLocalSecondaryIndex[];
    /**
     * point_in_time_recovery block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#point_in_time_recovery DynamodbTable#point_in_time_recovery}
     *
     * @stability stable
     */
    readonly pointInTimeRecovery?: DynamodbTablePointInTimeRecovery[];
    /**
     * replica block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#replica DynamodbTable#replica}
     *
     * @stability stable
     */
    readonly replica?: DynamodbTableReplica[];
    /**
     * server_side_encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#server_side_encryption DynamodbTable#server_side_encryption}
     *
     * @stability stable
     */
    readonly serverSideEncryption?: DynamodbTableServerSideEncryption[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#timeouts DynamodbTable#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DynamodbTableTimeouts;
    /**
     * ttl block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#ttl DynamodbTable#ttl}
     *
     * @stability stable
     */
    readonly ttl?: DynamodbTableTtl[];
}
/**
 * @stability stable
 */
export interface DynamodbTableAttribute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#name DynamodbTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#type DynamodbTable#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DynamodbTableGlobalSecondaryIndex {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#hash_key DynamodbTable#hash_key}.
     *
     * @stability stable
     */
    readonly hashKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#name DynamodbTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#non_key_attributes DynamodbTable#non_key_attributes}.
     *
     * @stability stable
     */
    readonly nonKeyAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#projection_type DynamodbTable#projection_type}.
     *
     * @stability stable
     */
    readonly projectionType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#range_key DynamodbTable#range_key}.
     *
     * @stability stable
     */
    readonly rangeKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#read_capacity DynamodbTable#read_capacity}.
     *
     * @stability stable
     */
    readonly readCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#write_capacity DynamodbTable#write_capacity}.
     *
     * @stability stable
     */
    readonly writeCapacity?: number;
}
/**
 * @stability stable
 */
export interface DynamodbTableLocalSecondaryIndex {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#name DynamodbTable#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#non_key_attributes DynamodbTable#non_key_attributes}.
     *
     * @stability stable
     */
    readonly nonKeyAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#projection_type DynamodbTable#projection_type}.
     *
     * @stability stable
     */
    readonly projectionType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#range_key DynamodbTable#range_key}.
     *
     * @stability stable
     */
    readonly rangeKey: string;
}
/**
 * @stability stable
 */
export interface DynamodbTablePointInTimeRecovery {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#enabled DynamodbTable#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface DynamodbTableReplica {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#kms_key_arn DynamodbTable#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#region_name DynamodbTable#region_name}.
     *
     * @stability stable
     */
    readonly regionName: string;
}
/**
 * @stability stable
 */
export interface DynamodbTableServerSideEncryption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#enabled DynamodbTable#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#kms_key_arn DynamodbTable#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface DynamodbTableTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#create DynamodbTable#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#delete DynamodbTable#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#update DynamodbTable#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface DynamodbTableTtl {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#attribute_name DynamodbTable#attribute_name}.
     *
     * @stability stable
     */
    readonly attributeName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#enabled DynamodbTable#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html#kms_key_arn DynamodbTable#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html aws_dynamodb_table}.
 *
 * @stability stable
 */
export declare class DynamodbTable extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table.html aws_dynamodb_table} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DynamodbTableConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _billingMode?;
    /**
     * @stability stable
     */
    get billingMode(): string;
    /**
     * @stability stable
     */
    set billingMode(value: string);
    /**
     * @stability stable
     */
    resetBillingMode(): void;
    /**
     * @stability stable
     */
    get billingModeInput(): string | undefined;
    private _hashKey;
    /**
     * @stability stable
     */
    get hashKey(): string;
    /**
     * @stability stable
     */
    set hashKey(value: string);
    /**
     * @stability stable
     */
    get hashKeyInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _rangeKey?;
    /**
     * @stability stable
     */
    get rangeKey(): string;
    /**
     * @stability stable
     */
    set rangeKey(value: string);
    /**
     * @stability stable
     */
    resetRangeKey(): void;
    /**
     * @stability stable
     */
    get rangeKeyInput(): string | undefined;
    private _readCapacity?;
    /**
     * @stability stable
     */
    get readCapacity(): number;
    /**
     * @stability stable
     */
    set readCapacity(value: number);
    /**
     * @stability stable
     */
    resetReadCapacity(): void;
    /**
     * @stability stable
     */
    get readCapacityInput(): number | undefined;
    /**
     * @stability stable
     */
    get streamArn(): string;
    private _streamEnabled?;
    /**
     * @stability stable
     */
    get streamEnabled(): boolean;
    /**
     * @stability stable
     */
    set streamEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetStreamEnabled(): void;
    /**
     * @stability stable
     */
    get streamEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get streamLabel(): string;
    private _streamViewType?;
    /**
     * @stability stable
     */
    get streamViewType(): string;
    /**
     * @stability stable
     */
    set streamViewType(value: string);
    /**
     * @stability stable
     */
    resetStreamViewType(): void;
    /**
     * @stability stable
     */
    get streamViewTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _writeCapacity?;
    /**
     * @stability stable
     */
    get writeCapacity(): number;
    /**
     * @stability stable
     */
    set writeCapacity(value: number);
    /**
     * @stability stable
     */
    resetWriteCapacity(): void;
    /**
     * @stability stable
     */
    get writeCapacityInput(): number | undefined;
    private _attribute;
    /**
     * @stability stable
     */
    get attribute(): DynamodbTableAttribute[];
    /**
     * @stability stable
     */
    set attribute(value: DynamodbTableAttribute[]);
    /**
     * @stability stable
     */
    get attributeInput(): DynamodbTableAttribute[];
    private _globalSecondaryIndex?;
    /**
     * @stability stable
     */
    get globalSecondaryIndex(): DynamodbTableGlobalSecondaryIndex[];
    /**
     * @stability stable
     */
    set globalSecondaryIndex(value: DynamodbTableGlobalSecondaryIndex[]);
    /**
     * @stability stable
     */
    resetGlobalSecondaryIndex(): void;
    /**
     * @stability stable
     */
    get globalSecondaryIndexInput(): DynamodbTableGlobalSecondaryIndex[] | undefined;
    private _localSecondaryIndex?;
    /**
     * @stability stable
     */
    get localSecondaryIndex(): DynamodbTableLocalSecondaryIndex[];
    /**
     * @stability stable
     */
    set localSecondaryIndex(value: DynamodbTableLocalSecondaryIndex[]);
    /**
     * @stability stable
     */
    resetLocalSecondaryIndex(): void;
    /**
     * @stability stable
     */
    get localSecondaryIndexInput(): DynamodbTableLocalSecondaryIndex[] | undefined;
    private _pointInTimeRecovery?;
    /**
     * @stability stable
     */
    get pointInTimeRecovery(): DynamodbTablePointInTimeRecovery[];
    /**
     * @stability stable
     */
    set pointInTimeRecovery(value: DynamodbTablePointInTimeRecovery[]);
    /**
     * @stability stable
     */
    resetPointInTimeRecovery(): void;
    /**
     * @stability stable
     */
    get pointInTimeRecoveryInput(): DynamodbTablePointInTimeRecovery[] | undefined;
    private _replica?;
    /**
     * @stability stable
     */
    get replica(): DynamodbTableReplica[];
    /**
     * @stability stable
     */
    set replica(value: DynamodbTableReplica[]);
    /**
     * @stability stable
     */
    resetReplica(): void;
    /**
     * @stability stable
     */
    get replicaInput(): DynamodbTableReplica[] | undefined;
    private _serverSideEncryption?;
    /**
     * @stability stable
     */
    get serverSideEncryption(): DynamodbTableServerSideEncryption[];
    /**
     * @stability stable
     */
    set serverSideEncryption(value: DynamodbTableServerSideEncryption[]);
    /**
     * @stability stable
     */
    resetServerSideEncryption(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionInput(): DynamodbTableServerSideEncryption[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DynamodbTableTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DynamodbTableTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DynamodbTableTimeouts | undefined;
    private _ttl?;
    /**
     * @stability stable
     */
    get ttl(): DynamodbTableTtl[];
    /**
     * @stability stable
     */
    set ttl(value: DynamodbTableTtl[]);
    /**
     * @stability stable
     */
    resetTtl(): void;
    /**
     * @stability stable
     */
    get ttlInput(): DynamodbTableTtl[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
