import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#name GlueSecurityConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * encryption_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#encryption_configuration GlueSecurityConfiguration#encryption_configuration}
     *
     * @stability stable
     */
    readonly encryptionConfiguration: GlueSecurityConfigurationEncryptionConfiguration[];
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationCloudwatchEncryption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#cloudwatch_encryption_mode GlueSecurityConfiguration#cloudwatch_encryption_mode}.
     *
     * @stability stable
     */
    readonly cloudwatchEncryptionMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#kms_key_arn GlueSecurityConfiguration#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationJobBookmarksEncryption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#job_bookmarks_encryption_mode GlueSecurityConfiguration#job_bookmarks_encryption_mode}.
     *
     * @stability stable
     */
    readonly jobBookmarksEncryptionMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#kms_key_arn GlueSecurityConfiguration#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationS3Encryption {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#kms_key_arn GlueSecurityConfiguration#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#s3_encryption_mode GlueSecurityConfiguration#s3_encryption_mode}.
     *
     * @stability stable
     */
    readonly s3EncryptionMode?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfiguration {
    /**
     * cloudwatch_encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#cloudwatch_encryption GlueSecurityConfiguration#cloudwatch_encryption}
     *
     * @stability stable
     */
    readonly cloudwatchEncryption: GlueSecurityConfigurationEncryptionConfigurationCloudwatchEncryption[];
    /**
     * job_bookmarks_encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#job_bookmarks_encryption GlueSecurityConfiguration#job_bookmarks_encryption}
     *
     * @stability stable
     */
    readonly jobBookmarksEncryption: GlueSecurityConfigurationEncryptionConfigurationJobBookmarksEncryption[];
    /**
     * s3_encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html#s3_encryption GlueSecurityConfiguration#s3_encryption}
     *
     * @stability stable
     */
    readonly s3Encryption: GlueSecurityConfigurationEncryptionConfigurationS3Encryption[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html aws_glue_security_configuration}.
 *
 * @stability stable
 */
export declare class GlueSecurityConfiguration extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glue_security_configuration.html aws_glue_security_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueSecurityConfigurationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _encryptionConfiguration;
    /**
     * @stability stable
     */
    get encryptionConfiguration(): GlueSecurityConfigurationEncryptionConfiguration[];
    /**
     * @stability stable
     */
    set encryptionConfiguration(value: GlueSecurityConfigurationEncryptionConfiguration[]);
    /**
     * @stability stable
     */
    get encryptionConfigurationInput(): GlueSecurityConfigurationEncryptionConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
