import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LakeformationPermissionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_id LakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_resource LakeformationPermissions#catalog_resource}.
     *
     * @stability stable
     */
    readonly catalogResource?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#permissions LakeformationPermissions#permissions}.
     *
     * @stability stable
     */
    readonly permissions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#permissions_with_grant_option LakeformationPermissions#permissions_with_grant_option}.
     *
     * @stability stable
     */
    readonly permissionsWithGrantOption?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#principal LakeformationPermissions#principal}.
     *
     * @stability stable
     */
    readonly principal: string;
    /**
     * data_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#data_location LakeformationPermissions#data_location}
     *
     * @stability stable
     */
    readonly dataLocation?: LakeformationPermissionsDataLocation[];
    /**
     * database block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#database LakeformationPermissions#database}
     *
     * @stability stable
     */
    readonly database?: LakeformationPermissionsDatabase[];
    /**
     * table block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#table LakeformationPermissions#table}
     *
     * @stability stable
     */
    readonly table?: LakeformationPermissionsTable[];
    /**
     * table_with_columns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#table_with_columns LakeformationPermissions#table_with_columns}
     *
     * @stability stable
     */
    readonly tableWithColumns?: LakeformationPermissionsTableWithColumns[];
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsDataLocation {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#arn LakeformationPermissions#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_id LakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsDatabase {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_id LakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#name LakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsTable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_id LakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#database_name LakeformationPermissions#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#name LakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#wildcard LakeformationPermissions#wildcard}.
     *
     * @stability stable
     */
    readonly wildcard?: boolean;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsTableWithColumns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#catalog_id LakeformationPermissions#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#column_names LakeformationPermissions#column_names}.
     *
     * @stability stable
     */
    readonly columnNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#database_name LakeformationPermissions#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#excluded_column_names LakeformationPermissions#excluded_column_names}.
     *
     * @stability stable
     */
    readonly excludedColumnNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#name LakeformationPermissions#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html#wildcard LakeformationPermissions#wildcard}.
     *
     * @stability stable
     */
    readonly wildcard?: boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html aws_lakeformation_permissions}.
 *
 * @stability stable
 */
export declare class LakeformationPermissions extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_permissions.html aws_lakeformation_permissions} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LakeformationPermissionsConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _catalogResource?;
    /**
     * @stability stable
     */
    get catalogResource(): boolean;
    /**
     * @stability stable
     */
    set catalogResource(value: boolean);
    /**
     * @stability stable
     */
    resetCatalogResource(): void;
    /**
     * @stability stable
     */
    get catalogResourceInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _permissions;
    /**
     * @stability stable
     */
    get permissions(): string[];
    /**
     * @stability stable
     */
    set permissions(value: string[]);
    /**
     * @stability stable
     */
    get permissionsInput(): string[];
    private _permissionsWithGrantOption?;
    /**
     * @stability stable
     */
    get permissionsWithGrantOption(): string[];
    /**
     * @stability stable
     */
    set permissionsWithGrantOption(value: string[]);
    /**
     * @stability stable
     */
    resetPermissionsWithGrantOption(): void;
    /**
     * @stability stable
     */
    get permissionsWithGrantOptionInput(): string[] | undefined;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _dataLocation?;
    /**
     * @stability stable
     */
    get dataLocation(): LakeformationPermissionsDataLocation[];
    /**
     * @stability stable
     */
    set dataLocation(value: LakeformationPermissionsDataLocation[]);
    /**
     * @stability stable
     */
    resetDataLocation(): void;
    /**
     * @stability stable
     */
    get dataLocationInput(): LakeformationPermissionsDataLocation[] | undefined;
    private _database?;
    /**
     * @stability stable
     */
    get database(): LakeformationPermissionsDatabase[];
    /**
     * @stability stable
     */
    set database(value: LakeformationPermissionsDatabase[]);
    /**
     * @stability stable
     */
    resetDatabase(): void;
    /**
     * @stability stable
     */
    get databaseInput(): LakeformationPermissionsDatabase[] | undefined;
    private _table?;
    /**
     * @stability stable
     */
    get table(): LakeformationPermissionsTable[];
    /**
     * @stability stable
     */
    set table(value: LakeformationPermissionsTable[]);
    /**
     * @stability stable
     */
    resetTable(): void;
    /**
     * @stability stable
     */
    get tableInput(): LakeformationPermissionsTable[] | undefined;
    private _tableWithColumns?;
    /**
     * @stability stable
     */
    get tableWithColumns(): LakeformationPermissionsTableWithColumns[];
    /**
     * @stability stable
     */
    set tableWithColumns(value: LakeformationPermissionsTableWithColumns[]);
    /**
     * @stability stable
     */
    resetTableWithColumns(): void;
    /**
     * @stability stable
     */
    get tableWithColumnsInput(): LakeformationPermissionsTableWithColumns[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
