import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LaunchConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#associate_public_ip_address LaunchConfiguration#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#ebs_optimized LaunchConfiguration#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#enable_monitoring LaunchConfiguration#enable_monitoring}.
     *
     * @stability stable
     */
    readonly enableMonitoring?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#iam_instance_profile LaunchConfiguration#iam_instance_profile}.
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#image_id LaunchConfiguration#image_id}.
     *
     * @stability stable
     */
    readonly imageId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#instance_type LaunchConfiguration#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#key_name LaunchConfiguration#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#name LaunchConfiguration#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#name_prefix LaunchConfiguration#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#placement_tenancy LaunchConfiguration#placement_tenancy}.
     *
     * @stability stable
     */
    readonly placementTenancy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#security_groups LaunchConfiguration#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#spot_price LaunchConfiguration#spot_price}.
     *
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#user_data LaunchConfiguration#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#user_data_base64 LaunchConfiguration#user_data_base64}.
     *
     * @stability stable
     */
    readonly userDataBase64?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#vpc_classic_link_id LaunchConfiguration#vpc_classic_link_id}.
     *
     * @stability stable
     */
    readonly vpcClassicLinkId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#vpc_classic_link_security_groups LaunchConfiguration#vpc_classic_link_security_groups}.
     *
     * @stability stable
     */
    readonly vpcClassicLinkSecurityGroups?: string[];
    /**
     * ebs_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#ebs_block_device LaunchConfiguration#ebs_block_device}
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: LaunchConfigurationEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#ephemeral_block_device LaunchConfiguration#ephemeral_block_device}
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: LaunchConfigurationEphemeralBlockDevice[];
    /**
     * metadata_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#metadata_options LaunchConfiguration#metadata_options}
     *
     * @stability stable
     */
    readonly metadataOptions?: LaunchConfigurationMetadataOptions[];
    /**
     * root_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#root_block_device LaunchConfiguration#root_block_device}
     *
     * @stability stable
     */
    readonly rootBlockDevice?: LaunchConfigurationRootBlockDevice[];
}
/**
 * @stability stable
 */
export interface LaunchConfigurationEbsBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#delete_on_termination LaunchConfiguration#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#device_name LaunchConfiguration#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#encrypted LaunchConfiguration#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#iops LaunchConfiguration#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#no_device LaunchConfiguration#no_device}.
     *
     * @stability stable
     */
    readonly noDevice?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#snapshot_id LaunchConfiguration#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#throughput LaunchConfiguration#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#volume_size LaunchConfiguration#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#volume_type LaunchConfiguration#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationEphemeralBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#device_name LaunchConfiguration#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#virtual_name LaunchConfiguration#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationMetadataOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#http_endpoint LaunchConfiguration#http_endpoint}.
     *
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#http_put_response_hop_limit LaunchConfiguration#http_put_response_hop_limit}.
     *
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#http_tokens LaunchConfiguration#http_tokens}.
     *
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationRootBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#delete_on_termination LaunchConfiguration#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#encrypted LaunchConfiguration#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#iops LaunchConfiguration#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#throughput LaunchConfiguration#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#volume_size LaunchConfiguration#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html#volume_type LaunchConfiguration#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html aws_launch_configuration}.
 *
 * @stability stable
 */
export declare class LaunchConfiguration extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/launch_configuration.html aws_launch_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LaunchConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _associatePublicIpAddress?;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    set associatePublicIpAddress(value: boolean);
    /**
     * @stability stable
     */
    resetAssociatePublicIpAddress(): void;
    /**
     * @stability stable
     */
    get associatePublicIpAddressInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    private _enableMonitoring?;
    /**
     * @stability stable
     */
    get enableMonitoring(): boolean;
    /**
     * @stability stable
     */
    set enableMonitoring(value: boolean);
    /**
     * @stability stable
     */
    resetEnableMonitoring(): void;
    /**
     * @stability stable
     */
    get enableMonitoringInput(): boolean | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: string);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    get imageIdInput(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _placementTenancy?;
    /**
     * @stability stable
     */
    get placementTenancy(): string;
    /**
     * @stability stable
     */
    set placementTenancy(value: string);
    /**
     * @stability stable
     */
    resetPlacementTenancy(): void;
    /**
     * @stability stable
     */
    get placementTenancyInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _spotPrice?;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    set spotPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotPrice(): void;
    /**
     * @stability stable
     */
    get spotPriceInput(): string | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _userDataBase64?;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    set userDataBase64(value: string);
    /**
     * @stability stable
     */
    resetUserDataBase64(): void;
    /**
     * @stability stable
     */
    get userDataBase64Input(): string | undefined;
    private _vpcClassicLinkId?;
    /**
     * @stability stable
     */
    get vpcClassicLinkId(): string;
    /**
     * @stability stable
     */
    set vpcClassicLinkId(value: string);
    /**
     * @stability stable
     */
    resetVpcClassicLinkId(): void;
    /**
     * @stability stable
     */
    get vpcClassicLinkIdInput(): string | undefined;
    private _vpcClassicLinkSecurityGroups?;
    /**
     * @stability stable
     */
    get vpcClassicLinkSecurityGroups(): string[];
    /**
     * @stability stable
     */
    set vpcClassicLinkSecurityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetVpcClassicLinkSecurityGroups(): void;
    /**
     * @stability stable
     */
    get vpcClassicLinkSecurityGroupsInput(): string[] | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): LaunchConfigurationEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: LaunchConfigurationEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): LaunchConfigurationEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): LaunchConfigurationEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: LaunchConfigurationEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): LaunchConfigurationEphemeralBlockDevice[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): LaunchConfigurationMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: LaunchConfigurationMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): LaunchConfigurationMetadataOptions[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): LaunchConfigurationRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: LaunchConfigurationRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): LaunchConfigurationRootBlockDevice[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
