import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MacieMemberAccountAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html#member_account_id MacieMemberAccountAssociation#member_account_id}.
     *
     * @stability stable
     */
    readonly memberAccountId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html aws_macie_member_account_association}.
 *
 * @stability stable
 */
export declare class MacieMemberAccountAssociation extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie_member_account_association.html aws_macie_member_account_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MacieMemberAccountAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _memberAccountId;
    /**
     * @stability stable
     */
    get memberAccountId(): string;
    /**
     * @stability stable
     */
    set memberAccountId(value: string);
    /**
     * @stability stable
     */
    get memberAccountIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
