import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MacieS3BucketAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#bucket_name MacieS3BucketAssociation#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#member_account_id MacieS3BucketAssociation#member_account_id}.
     *
     * @stability stable
     */
    readonly memberAccountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#prefix MacieS3BucketAssociation#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * classification_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#classification_type MacieS3BucketAssociation#classification_type}
     *
     * @stability stable
     */
    readonly classificationType?: MacieS3BucketAssociationClassificationType[];
}
/**
 * @stability stable
 */
export interface MacieS3BucketAssociationClassificationType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#continuous MacieS3BucketAssociation#continuous}.
     *
     * @stability stable
     */
    readonly continuous?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html#one_time MacieS3BucketAssociation#one_time}.
     *
     * @stability stable
     */
    readonly oneTime?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html aws_macie_s3_bucket_association}.
 *
 * @stability stable
 */
export declare class MacieS3BucketAssociation extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie_s3_bucket_association.html aws_macie_s3_bucket_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MacieS3BucketAssociationConfig);
    private _bucketName;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    get bucketNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _memberAccountId?;
    /**
     * @stability stable
     */
    get memberAccountId(): string;
    /**
     * @stability stable
     */
    set memberAccountId(value: string);
    /**
     * @stability stable
     */
    resetMemberAccountId(): void;
    /**
     * @stability stable
     */
    get memberAccountIdInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _classificationType?;
    /**
     * @stability stable
     */
    get classificationType(): MacieS3BucketAssociationClassificationType[];
    /**
     * @stability stable
     */
    set classificationType(value: MacieS3BucketAssociationClassificationType[]);
    /**
     * @stability stable
     */
    resetClassificationType(): void;
    /**
     * @stability stable
     */
    get classificationTypeInput(): MacieS3BucketAssociationClassificationType[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
