import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerCodeRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html#code_repository_name SagemakerCodeRepository#code_repository_name}.
     *
     * @stability stable
     */
    readonly codeRepositoryName: string;
    /**
     * git_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html#git_config SagemakerCodeRepository#git_config}
     *
     * @stability stable
     */
    readonly gitConfig: SagemakerCodeRepositoryGitConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerCodeRepositoryGitConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html#branch SagemakerCodeRepository#branch}.
     *
     * @stability stable
     */
    readonly branch?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html#repository_url SagemakerCodeRepository#repository_url}.
     *
     * @stability stable
     */
    readonly repositoryUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html#secret_arn SagemakerCodeRepository#secret_arn}.
     *
     * @stability stable
     */
    readonly secretArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html aws_sagemaker_code_repository}.
 *
 * @stability stable
 */
export declare class SagemakerCodeRepository extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_code_repository.html aws_sagemaker_code_repository} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerCodeRepositoryConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _codeRepositoryName;
    /**
     * @stability stable
     */
    get codeRepositoryName(): string;
    /**
     * @stability stable
     */
    set codeRepositoryName(value: string);
    /**
     * @stability stable
     */
    get codeRepositoryNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _gitConfig;
    /**
     * @stability stable
     */
    get gitConfig(): SagemakerCodeRepositoryGitConfig[];
    /**
     * @stability stable
     */
    set gitConfig(value: SagemakerCodeRepositoryGitConfig[]);
    /**
     * @stability stable
     */
    get gitConfigInput(): SagemakerCodeRepositoryGitConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
