import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SpotInstanceRequestConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ami SpotInstanceRequest#ami}.
     *
     * @stability stable
     */
    readonly ami: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#associate_public_ip_address SpotInstanceRequest#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#availability_zone SpotInstanceRequest#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#block_duration_minutes SpotInstanceRequest#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_core_count SpotInstanceRequest#cpu_core_count}.
     *
     * @stability stable
     */
    readonly cpuCoreCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_threads_per_core SpotInstanceRequest#cpu_threads_per_core}.
     *
     * @stability stable
     */
    readonly cpuThreadsPerCore?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#disable_api_termination SpotInstanceRequest#disable_api_termination}.
     *
     * @stability stable
     */
    readonly disableApiTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ebs_optimized SpotInstanceRequest#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#get_password_data SpotInstanceRequest#get_password_data}.
     *
     * @stability stable
     */
    readonly fetchPasswordData?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#hibernation SpotInstanceRequest#hibernation}.
     *
     * @stability stable
     */
    readonly hibernation?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#host_id SpotInstanceRequest#host_id}.
     *
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iam_instance_profile SpotInstanceRequest#iam_instance_profile}.
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_initiated_shutdown_behavior SpotInstanceRequest#instance_initiated_shutdown_behavior}.
     *
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_interruption_behaviour SpotInstanceRequest#instance_interruption_behaviour}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehaviour?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#instance_type SpotInstanceRequest#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ipv6_address_count SpotInstanceRequest#ipv6_address_count}.
     *
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ipv6_addresses SpotInstanceRequest#ipv6_addresses}.
     *
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#key_name SpotInstanceRequest#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#launch_group SpotInstanceRequest#launch_group}.
     *
     * @stability stable
     */
    readonly launchGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#monitoring SpotInstanceRequest#monitoring}.
     *
     * @stability stable
     */
    readonly monitoring?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#placement_group SpotInstanceRequest#placement_group}.
     *
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#private_ip SpotInstanceRequest#private_ip}.
     *
     * @stability stable
     */
    readonly privateIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#secondary_private_ips SpotInstanceRequest#secondary_private_ips}.
     *
     * @stability stable
     */
    readonly secondaryPrivateIps?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#security_groups SpotInstanceRequest#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#source_dest_check SpotInstanceRequest#source_dest_check}.
     *
     * @stability stable
     */
    readonly sourceDestCheck?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#spot_price SpotInstanceRequest#spot_price}.
     *
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#spot_type SpotInstanceRequest#spot_type}.
     *
     * @stability stable
     */
    readonly spotType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#subnet_id SpotInstanceRequest#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags_all SpotInstanceRequest#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tenancy SpotInstanceRequest#tenancy}.
     *
     * @stability stable
     */
    readonly tenancy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#user_data SpotInstanceRequest#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#user_data_base64 SpotInstanceRequest#user_data_base64}.
     *
     * @stability stable
     */
    readonly userDataBase64?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#valid_from SpotInstanceRequest#valid_from}.
     *
     * @stability stable
     */
    readonly validFrom?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#valid_until SpotInstanceRequest#valid_until}.
     *
     * @stability stable
     */
    readonly validUntil?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_tags SpotInstanceRequest#volume_tags}.
     *
     * @stability stable
     */
    readonly volumeTags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#vpc_security_group_ids SpotInstanceRequest#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#wait_for_fulfillment SpotInstanceRequest#wait_for_fulfillment}.
     *
     * @stability stable
     */
    readonly waitForFulfillment?: boolean;
    /**
     * capacity_reservation_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_specification SpotInstanceRequest#capacity_reservation_specification}
     *
     * @stability stable
     */
    readonly capacityReservationSpecification?: SpotInstanceRequestCapacityReservationSpecification[];
    /**
     * credit_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#credit_specification SpotInstanceRequest#credit_specification}
     *
     * @stability stable
     */
    readonly creditSpecification?: SpotInstanceRequestCreditSpecification[];
    /**
     * ebs_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ebs_block_device SpotInstanceRequest#ebs_block_device}
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: SpotInstanceRequestEbsBlockDevice[];
    /**
     * enclave_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#enclave_options SpotInstanceRequest#enclave_options}
     *
     * @stability stable
     */
    readonly enclaveOptions?: SpotInstanceRequestEnclaveOptions[];
    /**
     * ephemeral_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#ephemeral_block_device SpotInstanceRequest#ephemeral_block_device}
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: SpotInstanceRequestEphemeralBlockDevice[];
    /**
     * metadata_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#metadata_options SpotInstanceRequest#metadata_options}
     *
     * @stability stable
     */
    readonly metadataOptions?: SpotInstanceRequestMetadataOptions[];
    /**
     * network_interface block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#network_interface SpotInstanceRequest#network_interface}
     *
     * @stability stable
     */
    readonly networkInterface?: SpotInstanceRequestNetworkInterface[];
    /**
     * root_block_device block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#root_block_device SpotInstanceRequest#root_block_device}
     *
     * @stability stable
     */
    readonly rootBlockDevice?: SpotInstanceRequestRootBlockDevice[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#timeouts SpotInstanceRequest#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SpotInstanceRequestTimeouts;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_id SpotInstanceRequest#capacity_reservation_id}.
     *
     * @stability stable
     */
    readonly capacityReservationId?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestCapacityReservationSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_preference SpotInstanceRequest#capacity_reservation_preference}.
     *
     * @stability stable
     */
    readonly capacityReservationPreference?: string;
    /**
     * capacity_reservation_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#capacity_reservation_target SpotInstanceRequest#capacity_reservation_target}
     *
     * @stability stable
     */
    readonly capacityReservationTarget?: SpotInstanceRequestCapacityReservationSpecificationCapacityReservationTarget[];
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestCreditSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#cpu_credits SpotInstanceRequest#cpu_credits}.
     *
     * @stability stable
     */
    readonly cpuCredits?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestEbsBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_name SpotInstanceRequest#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#encrypted SpotInstanceRequest#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iops SpotInstanceRequest#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#kms_key_id SpotInstanceRequest#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#snapshot_id SpotInstanceRequest#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#throughput SpotInstanceRequest#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_size SpotInstanceRequest#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_type SpotInstanceRequest#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestEnclaveOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#enabled SpotInstanceRequest#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestEphemeralBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_name SpotInstanceRequest#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#no_device SpotInstanceRequest#no_device}.
     *
     * @stability stable
     */
    readonly noDevice?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#virtual_name SpotInstanceRequest#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestMetadataOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_endpoint SpotInstanceRequest#http_endpoint}.
     *
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_put_response_hop_limit SpotInstanceRequest#http_put_response_hop_limit}.
     *
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#http_tokens SpotInstanceRequest#http_tokens}.
     *
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestNetworkInterface {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#device_index SpotInstanceRequest#device_index}.
     *
     * @stability stable
     */
    readonly deviceIndex: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#network_interface_id SpotInstanceRequest#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestRootBlockDevice {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete_on_termination SpotInstanceRequest#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#encrypted SpotInstanceRequest#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#iops SpotInstanceRequest#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#kms_key_id SpotInstanceRequest#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#tags SpotInstanceRequest#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#throughput SpotInstanceRequest#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_size SpotInstanceRequest#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#volume_type SpotInstanceRequest#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotInstanceRequestTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#create SpotInstanceRequest#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html#delete SpotInstanceRequest#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html aws_spot_instance_request}.
 *
 * @stability stable
 */
export declare class SpotInstanceRequest extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/spot_instance_request.html aws_spot_instance_request} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SpotInstanceRequestConfig);
    private _ami;
    /**
     * @stability stable
     */
    get ami(): string;
    /**
     * @stability stable
     */
    set ami(value: string);
    /**
     * @stability stable
     */
    get amiInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _associatePublicIpAddress?;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    set associatePublicIpAddress(value: boolean);
    /**
     * @stability stable
     */
    resetAssociatePublicIpAddress(): void;
    /**
     * @stability stable
     */
    get associatePublicIpAddressInput(): boolean | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _blockDurationMinutes?;
    /**
     * @stability stable
     */
    get blockDurationMinutes(): number;
    /**
     * @stability stable
     */
    set blockDurationMinutes(value: number);
    /**
     * @stability stable
     */
    resetBlockDurationMinutes(): void;
    /**
     * @stability stable
     */
    get blockDurationMinutesInput(): number | undefined;
    private _cpuCoreCount?;
    /**
     * @stability stable
     */
    get cpuCoreCount(): number;
    /**
     * @stability stable
     */
    set cpuCoreCount(value: number);
    /**
     * @stability stable
     */
    resetCpuCoreCount(): void;
    /**
     * @stability stable
     */
    get cpuCoreCountInput(): number | undefined;
    private _cpuThreadsPerCore?;
    /**
     * @stability stable
     */
    get cpuThreadsPerCore(): number;
    /**
     * @stability stable
     */
    set cpuThreadsPerCore(value: number);
    /**
     * @stability stable
     */
    resetCpuThreadsPerCore(): void;
    /**
     * @stability stable
     */
    get cpuThreadsPerCoreInput(): number | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    private _getPasswordData?;
    /**
     * @stability stable
     */
    get fetchPasswordData(): boolean;
    /**
     * @stability stable
     */
    set fetchPasswordData(value: boolean);
    /**
     * @stability stable
     */
    resetFetchPasswordData(): void;
    /**
     * @stability stable
     */
    get fetchPasswordDataInput(): boolean | undefined;
    private _hibernation?;
    /**
     * @stability stable
     */
    get hibernation(): boolean;
    /**
     * @stability stable
     */
    set hibernation(value: boolean);
    /**
     * @stability stable
     */
    resetHibernation(): void;
    /**
     * @stability stable
     */
    get hibernationInput(): boolean | undefined;
    private _hostId?;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    set hostId(value: string);
    /**
     * @stability stable
     */
    resetHostId(): void;
    /**
     * @stability stable
     */
    get hostIdInput(): string | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: string);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    private _instanceInterruptionBehaviour?;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviour(): string;
    /**
     * @stability stable
     */
    set instanceInterruptionBehaviour(value: string);
    /**
     * @stability stable
     */
    resetInstanceInterruptionBehaviour(): void;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviourInput(): string | undefined;
    /**
     * @stability stable
     */
    get instanceState(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _ipv6AddressCount?;
    /**
     * @stability stable
     */
    get ipv6AddressCount(): number;
    /**
     * @stability stable
     */
    set ipv6AddressCount(value: number);
    /**
     * @stability stable
     */
    resetIpv6AddressCount(): void;
    /**
     * @stability stable
     */
    get ipv6AddressCountInput(): number | undefined;
    private _ipv6Addresses?;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    set ipv6Addresses(value: string[]);
    /**
     * @stability stable
     */
    resetIpv6Addresses(): void;
    /**
     * @stability stable
     */
    get ipv6AddressesInput(): string[] | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _launchGroup?;
    /**
     * @stability stable
     */
    get launchGroup(): string;
    /**
     * @stability stable
     */
    set launchGroup(value: string);
    /**
     * @stability stable
     */
    resetLaunchGroup(): void;
    /**
     * @stability stable
     */
    get launchGroupInput(): string | undefined;
    private _monitoring?;
    /**
     * @stability stable
     */
    get monitoring(): boolean;
    /**
     * @stability stable
     */
    set monitoring(value: boolean);
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get passwordData(): string;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    /**
     * @stability stable
     */
    get primaryNetworkInterfaceId(): string;
    /**
     * @stability stable
     */
    get privateDns(): string;
    private _privateIp?;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    set privateIp(value: string);
    /**
     * @stability stable
     */
    resetPrivateIp(): void;
    /**
     * @stability stable
     */
    get privateIpInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
    private _secondaryPrivateIps?;
    /**
     * @stability stable
     */
    get secondaryPrivateIps(): string[];
    /**
     * @stability stable
     */
    set secondaryPrivateIps(value: string[]);
    /**
     * @stability stable
     */
    resetSecondaryPrivateIps(): void;
    /**
     * @stability stable
     */
    get secondaryPrivateIpsInput(): string[] | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _sourceDestCheck?;
    /**
     * @stability stable
     */
    get sourceDestCheck(): boolean;
    /**
     * @stability stable
     */
    set sourceDestCheck(value: boolean);
    /**
     * @stability stable
     */
    resetSourceDestCheck(): void;
    /**
     * @stability stable
     */
    get sourceDestCheckInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get spotBidStatus(): string;
    /**
     * @stability stable
     */
    get spotInstanceId(): string;
    private _spotPrice?;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    set spotPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotPrice(): void;
    /**
     * @stability stable
     */
    get spotPriceInput(): string | undefined;
    /**
     * @stability stable
     */
    get spotRequestState(): string;
    private _spotType?;
    /**
     * @stability stable
     */
    get spotType(): string;
    /**
     * @stability stable
     */
    set spotType(value: string);
    /**
     * @stability stable
     */
    resetSpotType(): void;
    /**
     * @stability stable
     */
    get spotTypeInput(): string | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _userDataBase64?;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    set userDataBase64(value: string);
    /**
     * @stability stable
     */
    resetUserDataBase64(): void;
    /**
     * @stability stable
     */
    get userDataBase64Input(): string | undefined;
    private _validFrom?;
    /**
     * @stability stable
     */
    get validFrom(): string;
    /**
     * @stability stable
     */
    set validFrom(value: string);
    /**
     * @stability stable
     */
    resetValidFrom(): void;
    /**
     * @stability stable
     */
    get validFromInput(): string | undefined;
    private _validUntil?;
    /**
     * @stability stable
     */
    get validUntil(): string;
    /**
     * @stability stable
     */
    set validUntil(value: string);
    /**
     * @stability stable
     */
    resetValidUntil(): void;
    /**
     * @stability stable
     */
    get validUntilInput(): string | undefined;
    private _volumeTags?;
    /**
     * @stability stable
     */
    get volumeTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set volumeTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVolumeTags(): void;
    /**
     * @stability stable
     */
    get volumeTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _waitForFulfillment?;
    /**
     * @stability stable
     */
    get waitForFulfillment(): boolean;
    /**
     * @stability stable
     */
    set waitForFulfillment(value: boolean);
    /**
     * @stability stable
     */
    resetWaitForFulfillment(): void;
    /**
     * @stability stable
     */
    get waitForFulfillmentInput(): boolean | undefined;
    private _capacityReservationSpecification?;
    /**
     * @stability stable
     */
    get capacityReservationSpecification(): SpotInstanceRequestCapacityReservationSpecification[];
    /**
     * @stability stable
     */
    set capacityReservationSpecification(value: SpotInstanceRequestCapacityReservationSpecification[]);
    /**
     * @stability stable
     */
    resetCapacityReservationSpecification(): void;
    /**
     * @stability stable
     */
    get capacityReservationSpecificationInput(): SpotInstanceRequestCapacityReservationSpecification[] | undefined;
    private _creditSpecification?;
    /**
     * @stability stable
     */
    get creditSpecification(): SpotInstanceRequestCreditSpecification[];
    /**
     * @stability stable
     */
    set creditSpecification(value: SpotInstanceRequestCreditSpecification[]);
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): SpotInstanceRequestCreditSpecification[] | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): SpotInstanceRequestEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: SpotInstanceRequestEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): SpotInstanceRequestEbsBlockDevice[] | undefined;
    private _enclaveOptions?;
    /**
     * @stability stable
     */
    get enclaveOptions(): SpotInstanceRequestEnclaveOptions[];
    /**
     * @stability stable
     */
    set enclaveOptions(value: SpotInstanceRequestEnclaveOptions[]);
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): SpotInstanceRequestEnclaveOptions[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): SpotInstanceRequestEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: SpotInstanceRequestEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): SpotInstanceRequestEphemeralBlockDevice[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): SpotInstanceRequestMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: SpotInstanceRequestMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): SpotInstanceRequestMetadataOptions[] | undefined;
    private _networkInterface?;
    /**
     * @stability stable
     */
    get networkInterface(): SpotInstanceRequestNetworkInterface[];
    /**
     * @stability stable
     */
    set networkInterface(value: SpotInstanceRequestNetworkInterface[]);
    /**
     * @stability stable
     */
    resetNetworkInterface(): void;
    /**
     * @stability stable
     */
    get networkInterfaceInput(): SpotInstanceRequestNetworkInterface[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): SpotInstanceRequestRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: SpotInstanceRequestRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): SpotInstanceRequestRootBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SpotInstanceRequestTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SpotInstanceRequestTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SpotInstanceRequestTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
